import { ReactNode } from 'react';
import { RouteProps, useHistory } from 'react-router-dom';
import { RouteSlot } from '@teambit/ui-foundation.ui.react-router.slot-router';
import { ReactRouterUI } from './react-router.ui.runtime';
import { Routing } from './routing-method';
export declare type History = ReturnType<typeof useHistory>;
declare type RouterContextProps = {
    reactRouterUi: ReactRouterUI;
    routing?: Routing;
    children: ReactNode;
    location?: string;
};
declare type RootRouteProps = {
    rootRoutes: RouteProps[];
    routeSlot: RouteSlot;
};
/**
 * Setup context needed for routing.
 */
export declare function RouteContext({ reactRouterUi, routing, children, location }: RouterContextProps): JSX.Element;
export declare function RootRoute({ rootRoutes, routeSlot }: RootRouteProps): JSX.Element;
export {};
